module GranPulse
  class Url < Check
    attr_accessor :host, :port

    def initialize
      self.type = 'url'
    end

    def perform params
      self.host = URI.parse(params[:host]).host
      self.port = params[:port] || 80

      begin
        Timeout::timeout(1) do
          begin
            s = TCPSocket.new(host, port)
            s.close
            self.healthy = true
            self.message = 'ok'
          rescue Errno::ECONNREFUSED, Errno::EHOSTUNREACH => e
            self.healthy = false
            self.message = e
          end
        end
      rescue Timeout::Error
        self.healthy = false
        self.message = 'timeout'
      end
      self
    end
  end
end
